#ifndef WORD_REPLACER_TEST_CONNECTION_H
#define WORD_REPLACER_TEST_CONNECTION_H

#include "PA_SmppConnection.h"
#include "PA_LongRangeDialogIdManager.h"

class WR_Connection : public PA_SmppConnection
{
    public:
        WR_Connection();
        virtual ~WR_Connection();

        virtual PDU* CreatePdu ( UInteger packetId );
        virtual ResponsePDU* GenerateResponsePdu ( unsigned int originalPduType, unsigned int seqNo, int err );

        int 	SetConfigParameter ( const string& name, const string& value );

	int 	OnReconfigurationComplete();

        UInteger	GetWordReplacerOid();
        void		SetWordReplacerOid ( ManagedObjectId oid );

        UInteger	GetExternalClientOid();
        void		SetExternalClientOid ( ManagedObjectId oid );


    private:
        ManagedObjectId		mWordReplacerOid;
        ManagedObjectId		mExternalClientOid;
        PA_LongRangeDialogIdManager* mDialogIdManager;
};

#endif
