#ifndef WORD_REPLACER_EXTERNALCLIENT_H
#define WORD_REPLACER_EXTERNALCLIENT_H

#include "PA_SmppExternalClient.h"

class WR_ExternalClient : public PA_SmppExternalClient
{
    public:
        WR_ExternalClient();
        virtual ~WR_ExternalClient();

        virtual IManagedObject* CreateManagedObject ( const string& nodeName );

        virtual int SetConfigParameter ( const string& name,  const string& value );

	virtual void GetMonitoringVariables ( vector<MonitoringVariable>& mvl );

        void SetWordReplacerOid ( ManagedObjectId oid );

	time_t		CheckLicense ();
	
	MonitoringVariable	mReceivedPackets;

    private:
        ManagedObjectId		mWordReplacerOid;
	unsigned long		mWordReplacementLicensePerMinute;
	time_t			mLastMinuteStart;
	int			mUsageCount;
	pthread_mutex_t		mMutex;
};

#endif
