#include "WR_Server.h"
#include "WR_Connection.h"
#include "WR_ExternalClientsTable.h"

WR_Server::WR_Server()
{
}

WR_Server::~WR_Server()
{
}

IManagedObject* WR_Server::CreateManagedObject ( const string& nodeName )
{
    IManagedObject* obj = NULL;

    if ( nodeName == "DefaultConnectionTemplate" )
    {
        WR_Connection* wrc = new WR_Connection();
	paCountAlloc (wrc);
        wrc->SetWordReplacerOid ( mWordReplacerOid );
        obj = wrc;
    }
    else if ( nodeName ==  "ExternalClientsTable" )
    {
        WR_ExternalClientsTable* wrect = new WR_ExternalClientsTable();
	paCountAlloc (wrect);
        wrect->SetWordReplacerOid ( mWordReplacerOid );
        obj = wrect;
    }
    else
    {
        obj = PA_SmppServer::CreateManagedObject ( nodeName );
    }

    return obj;
}

void WR_Server::SetWordReplacerOid ( ManagedObjectId oid )
{
    mWordReplacerOid = oid;
}
