#include "WR_Submit.h"
#include "WR_Connection.h"
#include "WordReplacer.h"
#include "DeliverSm.h"
#include "SubmitSmResp.h"
#include "PA_SmartPointer.h"
#include "ManagedObjectsAgentBase.h"
#include "WR_ExternalClient.h"

WR_Submit::WR_Submit()
{
}

WR_Submit::~WR_Submit()
{
}

int WR_Submit::Process ( void* conn )
{
	PAMETHODENTRY;

	string				txt;
	string				newTxt;
	UInteger			wroid;
	UInteger			exclientoid;

	UserData			userData;
	SmppError 			commandStatus;
	string				messageId;
	DeliverSm*			deliverPacket;
	string				systemId;

	WR_Connection*	smppCon = ( WR_Connection* ) conn;
	SubmitSmResp*	ssr = new SubmitSmResp();
	paCountAlloc (ssr);

	exclientoid = smppCon->GetExternalClientOid();
	paGetManagedObject ( externalClient, exclientoid, WR_ExternalClient );

	wroid = smppCon->GetWordReplacerOid();
	paGetManagedObject ( wordReplacer, wroid, WordReplacer );

	if ( wordReplacer && externalClient)
	{
		externalClient->mReceivedPackets++;
		txt = mUserData.GetBodyTextInLatin1();

		try
		{
			for (unsigned int i = 0; i < txt.size(); i++)
			{
				string word, word2;
				for (;i < txt.size() && txt[i] != '\n' && txt[i] != ' ';i++)
				{
					word += txt[i];
				}

				time_t	remainingSeconds = externalClient->CheckLicense ();
				if (remainingSeconds == 0)
				{
					word2  = wordReplacer->ReplaceWord ( word );
				}
				else
				{
					char buff[128];
					sprintf (buff, "License limit exceeded. Please  wait %d seconds.", remainingSeconds);
					throw (string(buff));
				}

				newTxt  += word2;
				newTxt  += ' ';
			}
		}
		catch (string& err)
		{
			newTxt = err;
		}

		userData.Initialize ( "", newTxt, DCT_GSM_03_38 );

		commandStatus.SetError ( 0 );
		messageId = "1";

		ssr->Initialize ( mSequenceNumber, commandStatus, messageId );

		smppCon->Send ( ssr );

		Address addr;
		addr.Initialize ( 0, 0, "9892524" );

		ESMClass esmClass;
		esmClass.mMessagingMode = ESM_DEFAULT_SMSC_MODE;
		esmClass.mMessageType = DEFAULT_MESSAGE_TYPE;
		esmClass.mGsmNetworkSpecificFeatures = NO_SPECIFIC_FEATURES_SELECTED;

		RegisteredDelivery registeredDelivery;
		registeredDelivery.mSmscDeliveryReceipt = NO_SMSC_DELIVERY_RECEIPT_REQUESTED;
		registeredDelivery.mSmeOriginatedAcknowledgment = NO_SME_RECIPIENT_ACKNOWLEDGMENT;
		registeredDelivery.mIntermediateNotification = NO_INTERMEDIATE_NOTIFICATION;

		deliverPacket = new DeliverSm();
		paCountAlloc (deliverPacket);
		deliverPacket->Initialize ( 0 /*sequenceNumber*/,
				DEFAULT_SERVICE /*serviceType*/,
				addr /*sourceAddr*/,
				addr /*destinationAddr*/,
				esmClass,
				GSM_MOBILE_STATION /*protocolIdentifier*/,
				( _Byte ) 0 /* priorityFlag*/,
				time ( NULL ) /*scheduleDeliveryTime*/,
				time ( NULL ) + 3600 /*validityPeriod*/,
				registeredDelivery,
				RIPF_DO_NOT_REPLACE /*replaceIfPresentFlag*/,
				DC_SMSC_DEFAULT_ALPHABET /*dataCoding*/,
				( _Byte ) 0 /*mDefaultMsgId*/,
				userData );

		smppCon->Send ( deliverPacket );
	}

	PAMETHODRETURN ( 0 );
}
