#ifndef WORD_REPLACER_H
#define WORD_REPLACER_H

#include "SimpleManagedObject.h"
#include "WordReplacementRulesList.h"
#include "WR_Server.h"

class WordReplacer: public SimpleManagedObject
{
    public:
        WordReplacer();
        virtual ~WordReplacer();

        virtual void SetChildManagedObject ( const string& name, IManagedObject* object );
        virtual IManagedObject* CreateManagedObject ( const string& nodeName );
  	virtual void GetMonitoringVariables ( vector<MonitoringVariable>& mvl );
	virtual int RunAction ( const string& actionName, const map<string, string>& params, vector<string>& result );

        string ReplaceWord ( const string& origWord );

    private:
        WR_Server*			mWordReplacerServer;
        WordReplacementRulesList*	mWordReplacementRulesList;
	MonitoringVariable		mReplacedWordsCount;
};

#endif
